VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Maths"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'
' Maths class
'
'
'  28-06-00 : REC bug fixed
'  23-06-00 : Set to Global

Public Function VNormalize(dVector As D3DVECTOR) As D3DVECTOR
     DirectX.VectorNormalize dVector
  VNormalize = dVector
End Function
Public Function VScale(dV1 As D3DVECTOR, TScale As Single) As D3DVECTOR
 VScale = Vector(dV1.x * TScale, dV1.y * TScale, dV1.z * TScale)
End Function


Public Function VAdd(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As D3DVECTOR
    VAdd.x = dV1.x + dV2.x
    VAdd.y = dV1.y + dV2.y
    VAdd.z = dV1.z + dV2.z
End Function

Public Function VReflect(dRay As D3DVECTOR, dReflector As D3DVECTOR) As D3DVECTOR
    DirectX.VectorReflect VReflect, dRay, dReflector
End Function

Public Function VSubtract(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As D3DVECTOR
    VSubtract.x = dV1.x - dV2.x
    VSubtract.y = dV1.y - dV2.y
    VSubtract.z = dV1.z - dV2.z
End Function


Public Function ColorValue(r, g, b, a) As D3DCOLORVALUE
 With ColorValue
  .a = a
  .b = b
  .g = g
  .r = r
 End With
End Function

Public Function CrossProduct(v1 As D3DVECTOR, v2 As D3DVECTOR) As D3DVECTOR
  DirectX.VectorCrossProduct CrossProduct, v1, v2
End Function
Public Function DecomposePixel(Color As Long) As D3DCOLORVALUE
  DecomposeColor3D.b = DirectX.ColorGetBlue(Color)
  DecomposeColor3D.a = DirectX.ColorGetAlpha(Color)
  DecomposeColor3D.g = DirectX.ColorGetGreen(Color)
  DecomposeColor3D.r = DirectX.ColorGetRed(Color)
End Function


Public Function DotProduct(v1 As D3DVECTOR, v2 As D3DVECTOR) As Single
  DotProduct = DirectX.VectorDotProduct(v1, v2)
End Function

Public Function LVertex(x, y, z, Color, tu, tv) As D3DLVERTEX
 With LVertex
  .x = x
  .y = y
  .z = z
  .Color = Color
  .Specular = Color
  .tu = tu
  .tv = tv
 End With
End Function
Public Function TLVertex(x, y, z, Color, tu, tv) As D3DTLVERTEX
 With TLVertex
  .sx = x
  .sy = y
  .sz = z
  .Color = Color
  .Specular = Color
  .tu = tu
  .tv = tv
  .rhw = 0.5
 End With
End Function
Public Function REC(x, y, x1, Y1) As RECT
  REC.Left = x
  REC.Right = x1
  REC.Top = y
  REC.Bottom = Y1
End Function


Public Function RGBA(r, g, b, a) As Long
   RGBA = DirectX.CreateColorRGBA(r, g, b, a)
End Function
Public Function RGBA256(r, g, b, a) As Long
   RGBA256 = DirectX.CreateColorRGBA(r / 255, g / 255, b / 255, a / 255)
End Function
Public Function Vertex(x, y, z, nx, ny, nz, tu, tv) As D3DVERTEX
 With Vertex
  .x = x
  .y = y
  .z = z
  .nx = nx
  .ny = ny
  .nz = nz
  .tu = tu
  .tv = tv
 End With
End Function
Function Vector(x, y, z) As D3DVECTOR
 Vector.x = x
 Vector.y = y
 Vector.z = z
End Function


