VERSION 5.00
Begin VB.Form Form2 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "TrueVision Engine 0.8"
   ClientHeight    =   2985
   ClientLeft      =   4110
   ClientTop       =   2040
   ClientWidth     =   7755
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2985
   ScaleWidth      =   7755
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton Command1 
      Caption         =   "Cancel"
      Height          =   435
      Index           =   1
      Left            =   6015
      TabIndex        =   9
      Top             =   2430
      Width           =   1245
   End
   Begin VB.ComboBox Combo3 
      Height          =   315
      Left            =   4125
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   690
      Width           =   3360
   End
   Begin VB.CommandButton Command1 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   435
      Index           =   0
      Left            =   4275
      TabIndex        =   6
      Top             =   2445
      Width           =   1245
   End
   Begin VB.ComboBox Combo2 
      Height          =   315
      Left            =   4140
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   1965
      Width           =   3330
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   4140
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   1320
      Width           =   3330
   End
   Begin VB.Label Label2 
      Caption         =   "Choose a DirectDraw driver :"
      Height          =   270
      Index           =   2
      Left            =   4125
      TabIndex        =   8
      Top             =   450
      Width           =   1965
   End
   Begin VB.Label Label3 
      Caption         =   "FOR VISUAL BASIC"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   420
      Left            =   540
      TabIndex        =   4
      Top             =   2400
      Width           =   2970
   End
   Begin VB.Label Label2 
      Caption         =   "Choose a Direct3D driver :"
      Height          =   270
      Index           =   1
      Left            =   4155
      TabIndex        =   3
      Top             =   1740
      Width           =   1965
   End
   Begin VB.Label Label2 
      Caption         =   "Choose a video mode: "
      Height          =   270
      Index           =   0
      Left            =   4140
      TabIndex        =   1
      Top             =   1080
      Width           =   1845
   End
   Begin VB.Label Label1 
      Caption         =   "Driver && Resolution selection"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   330
      Left            =   3930
      TabIndex        =   0
      Top             =   60
      Width           =   3675
   End
   Begin VB.Image Image1 
      Height          =   2010
      Left            =   165
      Picture         =   "SelectDriver.frx":0000
      Stretch         =   -1  'True
      Top             =   195
      Width           =   3570
   End
End
Attribute VB_Name = "Form2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
 Dim DDEnum As DirectDrawEnum
 Dim DDMode As DirectDrawEnumModes
 Dim D3DEnum As Direct3DEnumDevices

 Public Commit As Boolean, MWidth As Long, MHeight As Long, MBPP As Long
 Public DirectDrawGuid, Direct3DGuid
 
Sub Fill3DMode(DisplayDevice As Integer)
  On Error GoTo GestError
   Dim DD2 As DirectDraw7
   Set DD2 = DirectX.DirectDrawCreate(DDEnum.GetGuid(DisplayDevice))
  
  Dim ddsd As DDSURFACEDESC2
  Set DDMode = DD2.GetDisplayModesEnum(DDEDM_DEFAULT, ddsd)
  
  Dim desc As DDSURFACEDESC2
  Combo1.Clear
  CurrentWidth = Val(GetSetting("TrueVision", "CurrentMode", "Width", "640"))
  CurrentHeight = Val(GetSetting("TrueVision", "CurrentMode", "Height", "480"))
  CurrentBBP = Val(GetSetting("TrueVision", "CurrentMode", "BBP", "16"))
  For i = 1 To DDMode.GetCount
    DDMode.GetItem i, desc
    Combo1.AddItem CStr(desc.lWidth) + "x" + CStr(desc.lHeight) + "x" + CStr(desc.ddpfPixelFormat.lRGBBitCount)
    If CurrentWidth = desc.lWidth And CurrentHeight = desc.lHeight And CurrentBBP = desc.ddpfPixelFormat.lRGBBitCount Then
     Found = i
    End If
  Next i
  
  Combo1.ListIndex = Found - 1
  Found = 0
  
  Dim direct3d As Direct3D7
  Set direct3d = DD2.GetDirect3D
  Set D3DEnum = direct3d.GetDevicesEnum
  
  
  DevGUID = GetSetting("TrueVision", "CurrentMode", "Direct3D GUID", "")
  Combo2.Clear
  For i = 1 To D3DEnum.GetCount
    Combo2.AddItem D3DEnum.GetDescription(i)
    If D3DEnum.GetGuid(i) = DevGUID Then
     Found = i
    End If
  Next i
  If Found = 0 Then
   Found = D3DEnum.GetCount
  End If
  Combo2.ListIndex = Found - 1
  
  Exit Sub
  
GestError:
  MsgBox "Error in Fill3D mode " + Err.Description + " " + CStr(Err.Number), vbCritical, "Error !"
  Err.Clear
  
End Sub

Sub FillDDEnum()
 Dim Found As Integer

 Set DDEnum = DirectX.GetDDEnum
 Combo3.Clear
 Guid = GetSetting("TrueVision", "CurrentMode", "DirectDrawGuid", "")
 For i = 1 To DDEnum.GetCount
   Combo3.AddItem DDEnum.GetDescription(i)
   If Guid = DDEnum.GetGuid(i) Then
    Combo3.ListIndex = i - 1
    Found = i
   End If
 Next i
 
 Fill3DMode Found
 
End Sub

Private Sub Combo3_Click()
  Fill3DMode Combo3.ListIndex + 1
End Sub


Private Sub Command1_Click(Index As Integer)
 If Index = 0 Then
 video = Combo1.Text
 insx = InStr(video, "x")
 MWidth = Val(Left(video, insx - 1))
 reste = Mid(video, insx + 1)
 
 insx = InStr(reste, "x")
 MHeight = Val(Left(reste, insx - 1))
 MBPP = Val(Mid(reste, insx + 1))
 
 DirectDrawGuid = DDEnum.GetGuid(Combo3.ListIndex + 1)
 Direct3DGuid = D3DEnum.GetGuid(Combo2.ListIndex + 1)
 
 Commit = True
 End If
 
 Hide
 
End Sub

Private Sub Form_Load()
 FillDDEnum
 Commit = False
End Sub

