VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SpecialEffects"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Private VX(4) As D3DTLVERTEX
Private Inited As Boolean
Private Fade As Single
Public FadeFinish As Boolean
Private FadeSpeed As Single
Private FlashN As Single
Public FlashFinish As Boolean
Private FlashSpeed As Single

Private PartSys(10) As ParticleSystem
  Dim Matrix As D3DMATRIX
Private BS As BillboardSystem


Public Sub EnableFog(fog As Boolean)
  Device.SetRenderState D3DRENDERSTATE_FOGENABLE, fog
End Sub
Public Sub Flash(r, g, b)
   If SystemFrame > 200 Or SystemFrame = 0 Then
    sf = 50
   Else
    sf = SystemFrame
   End If
   FlashN = FlashN + sf / FlashSpeed
   If FlashN > 1 Then FlashFinish = True
   For i = 1 To 4
     VX(i).Color = DirectX.CreateColorRGBA(r * (1 - FlashN), g * (1 - FlashN), b * (1 - FlashN), 1 - FlashN)
   Next i
   Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
   Device.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
   Device.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE
  Device.SetTexture 0, Nothing
   Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_TLVERTEX, VX(1), 4, D3DDP_DEFAULT

       Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
End Sub

Public Function FadeOut()
    If SystemFrame > 200 Or SystemFrame = 0 Then
    sf = 50
   Else
    sf = SystemFrame
   End If
   Fade = Fade + sf / FadeSpeed
      If Fade > 1 Then FadeFinish = True
   For i = 1 To 4
     VX(i).Color = DirectX.CreateColorRGBA(0, 0, 0, Fade)
   Next i
   Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
   Device.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
   Device.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA
  Device.SetTexture 0, Nothing
   Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_TLVERTEX, VX(1), 4, D3DDP_DEFAULT

       Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
  
  FadeOut = Fade

End Function


Function GetPartSystemActive(Index As Integer) As Boolean
  GetPartSystemActive = PartSys(Index).Active
End Function

Function InitBillboardParticleSystem(ParticleCount As Integer, ParticleStart As Integer, SquareSize As Single, Position As D3DVECTOR, Radius As Single, texture As texture) As BillboardSystem
   Set BS = New BillboardSystem
   BS.CreateBillboardSystem ParticleCount, ParticleStart, SquareSize, Position, Radius, texture
   Set InitBillboardParticleSystem = BS
   AddLog "Billboard particles system initialized..."
End Function

Sub InitFade()
 Fade = 0
 FadeFinish = False
End Sub

Sub InitFlash()
 FlashN = 0
 FlashFinish = False
End Sub
Sub InitPointParticleSystem(Index As Integer, Position As D3DVECTOR, Radius As Single, SystemType As Integer, ParticleCount As Integer, Color As Long, Direction As D3DVECTOR, Optional LifeTime As Single = 1, Optional Gravity As Single = 0, Optional Speed As Single = 1, Optional StartPart As Integer = 0, Optional GenerateParticleSpeed As Single = 0.001)
   ReDim Preserve PartSys(Index).Particle(ParticleCount)
   ReDim Preserve PartSys(Index).Vertex(ParticleCount)
   'If IsMissing(Direction) Then
   ' Direction = Vector(0, -1, 0)
   'End If
   r = DirectX.ColorGetRed(Color)
   g = DirectX.ColorGetGreen(Color)
   b = DirectX.ColorGetBlue(Color)
   PartSys(Index).Gravity = Gravity
   PartSys(Index).type = SystemType
   PartSys(Index).Speed = Speed
   PartSys(Index).Radius = Radius
   PartSys(Index).Position = Position
   PartSys(Index).Color = Color
   PartSys(Index).GenerateSpeed = GenerateParticleSpeed
   PartSys(Index).Direction = Direction
   PartSys(Index).Active = True
   If StartPart = 0 Then StartPart = ParticleCount
   PartSys(Index).NbParticle = StartPart
   Randomize Timer
   If SystemType = 1 Then
     'AddLog "Prepare Explosion : " + CStr(ParticleCount)
         For i = 1 To ParticleCount
      With PartSys(Index).Particle(i)
        .LifeTime = LifeTime
        .TimeAct = 0
        .Active = True
        PartSys(Index).Vertex(i) = LVertex(Position.x + Rnd * Radius - Radius / 2, Position.y + Rnd * Radius - Radius / 2, Position.z + Rnd * Radius - Radius / 2, Color, 1, 1)
        .Direction = Vector(Rnd * 2 - 1, Rnd * 2 - 1, Rnd * 2 - 1)
        DirectX.VectorNormalize .Direction
      End With
      
     Next i
   End If
   If SystemType = 2 Then
      For i = 1 To ParticleCount
       PartSys(Index).Particle(i).LifeTime = LifeTime
      Next i
      
     For i = 1 To StartPart
     With PartSys(Index).Particle(i)
        .LifeTime = LifeTime
        .TimeAct = 0
        .Active = True
        PartSys(Index).Vertex(i) = LVertex(Position.x + Rnd * Radius - Radius / 2, Position.y + Rnd * Radius - Radius / 2, Position.z + Rnd * Radius - Radius / 2, Color, 1, 1)
        .Direction = Direction
        DirectX.VectorNormalize .Direction
      End With
      Next i
   End If
   
End Sub
Sub InitSpecialEffects()
 Inited = True
  
  VX(1) = TLVertex(0, 0, 0, DirectX.CreateColorRGBA(1, 1, 1, 1), 0, 0)
  VX(2) = TLVertex(ViewPort.lWidth, 0, 0, DirectX.CreateColorRGBA(1, 1, 1, 1), 1, 0)
  VX(4) = TLVertex(ViewPort.lWidth, ViewPort.lHeight - 1, 0, DirectX.CreateColorRGBA(1, 1, 1, 1), 1, 1)
  VX(3) = TLVertex(0, ViewPort.lHeight, 0, DirectX.CreateColorRGBA(1, 1, 1, 1), 0, 1)
 Fade = 0
 FadeSpeed = 5000
 FlashN = 0
 FlashSpeed = 100
End Sub
Function FadeIn()
   If SystemFrame > 200 Or SystemFrame = 0 Then
    sf = 50
   Else
    sf = SystemFrame
   End If
   Fade = Fade + sf / FadeSpeed
   If Fade > 1 Then FadeFinish = True
   For i = 1 To 4
     VX(i).Color = DirectX.CreateColorRGBA(0, 0, 0, 1 - Fade)
   Next i
   Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
   Device.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
   Device.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA
  Device.SetTexture 0, Nothing
   Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_TLVERTEX, VX(1), 4, D3DDP_DEFAULT

       Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
  
  FadeIn = Fade
End Function
Public Sub RenderUpdateBillboardSystem()
   BS.RenderBillboardSystem
   BS.UpdateParticles
End Sub

Public Sub SetFadeSpeed(Speed As Long)
 FadeSpeed = Speed
End Sub

Public Sub SetFlashSpeed(Speed As Long)
 FlashSpeed = Speed
End Sub
Public Sub SetNightEffect(Optional BlueFactor As Single, Optional NightFactor As Single)
   If IsMissing(BlueFactor) = True Then
    BlueFactor = 0.1
   End If
   If IsMissing(NightFactor) = True Then
    NightFactor = 0.3
   End If
   
  SetSceneFog 0, 0, 0, NightFactor / 10
  BackGround = DirectX.CreateColorRGBA(0, 0, BlueFactor, 1)
End Sub

Public Sub SetSceneFog(r, g, b, Density As Single, Optional FogStart As Single = 1, Optional FogEnd As Single = 10000)
 
 Device.SetRenderStateSingle D3DRENDERSTATE_FOGEND, FogEnd
 Device.SetRenderStateSingle D3DRENDERSTATE_FOGSTART, FogStart
 Device.SetRenderState D3DRENDERSTATE_FOGVERTEXMODE, D3DFOG_LINEAR
 Device.SetRenderState D3DRENDERSTATE_FOGENABLE, True
 Device.SetRenderStateSingle D3DRENDERSTATE_FOGDENSITY, Density
 Device.SetRenderState D3DRENDERSTATE_FOGCOLOR, DirectX.CreateColorRGBA(r, g, b, 1)
End Sub

Sub UpdateRenderParticle(Index As Integer)


 If PartSys(Index).Active = False Then Exit Sub
  Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
  Device.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA
  Device.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE
  Device.SetTexture 0, Nothing
  Device.SetTransform D3DTRANSFORMSTATE_WORLD, Matrix
  Device.DrawPrimitive D3DPT_POINTLIST, D3DFVF_LVERTEX, PartSys(Index).Vertex(1), UBound(PartSys(Index).Vertex()), D3DDP_DEFAULT
  
  For i = 1 To UBound(PartSys(Index).Particle)
   
   With PartSys(Index)
    If .Particle(i).Active = True Then
      .Vertex(i).x = .Vertex(i).x + .Particle(i).Direction.x * SystemFrame / 100 * .Speed
      .Vertex(i).y = .Vertex(i).y + .Particle(i).Direction.y * SystemFrame / 100 * .Speed
      .Vertex(i).z = .Vertex(i).z + .Particle(i).Direction.z * SystemFrame / 100 * .Speed
      .Particle(i).TimeAct = .Particle(i).TimeAct + SystemFrame / 1000
      .Particle(i).Direction.y = .Particle(i).Direction.y - .Gravity / 1000
      If .Particle(i).TimeAct > .Particle(i).LifeTime Then
        If .type = 1 Then
          .NbParticle = .NbParticle - 1
          With PartSys(Index).Particle(i)
           .Active = False
        
           .TimeAct = 0
            Randomize Timer
           'PartSys(index).Vertex(I) = LVertex(PartSys(index).Position.x + Rnd * PartSys(index).Radius - PartSys(index).Radius / 2, PartSys(index).Position.y + Rnd * PartSys(index).Radius - PartSys(index).Radius / 2, PartSys(index).Position.z + Rnd * PartSys(index).Radius - PartSys(index).Radius / 2, PartSys(index).Color, 1, 1)
           If PartSys(Index).type = 1 Then
             .Direction = Vector(Rnd * 2 - 1, Rnd * 2 - 1, Rnd * 2 - 1)
          Else
        
           End If
           DirectX.VectorNormalize .Direction
           End With
        End If
        If .type = 2 Then
       ' With PartSys(index)
          .Particle(i).Active = False
          .Particle(i).TimeAct = 0
          .Vertex(i).x = 0
          .Vertex(i).y = 0
          .Vertex(i).z = 0
          .NbParticle = .NbParticle - 1
       ' End With
        End If
    End If
    Else
      If .type = 2 Then
        If Rnd < .GenerateSpeed Then
         .Particle(i).Active = True
         .Vertex(i) = LVertex(.Position.x + Rnd * .Radius - .Radius / 2, .Position.y + Rnd * .Radius - .Radius / 2, .Position.z + Rnd * .Radius - .Radius / 2, .Color, 1, 1)
         .Particle(i).TimeAct = 0
         
         .Particle(i).Direction = .Direction
         .NbParticle = .NbParticle + 1
        End If
      End If
    End If
    
   End With
   
  Next i
 If PartSys(Index).NbParticle = 0 Then
  PartSys(Index).Active = False
 End If
End Sub


Private Sub Class_Initialize()
  DirectX.IdentityMatrix Matrix
End Sub


