VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Texture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Public Name As String
Public TextureIndex As Integer
Public THeight As Integer
Public TWidth As Integer
Public filename As String


Public Property Get GetSurface() As DirectDrawSurface7
  Set GetSurface = texture(TextureIndex)
End Property


Public Sub LoadFromBMP(BitmapFile As String, Optional width As Integer, Optional height As Integer, Optional ColorKey As Long)
   NameTex = BitmapFile
   Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim i As Long
    Dim ddsd3 As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean
    On Error GoTo 789
    ddsd3.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If IsMissing(width) Then w = 0: h = 0 Else w = width: h = height
    If ((h <> 0) And (w <> 0)) Then
        ddsd3.lFlags = ddsd3.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        ddsd3.lHeight = h
        ddsd3.lWidth = w
    End If
    
     
    Set enumTex = Device.GetTextureFormatsEnum()
    
   
    For i = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(i, ddsd3.ddpfPixelFormat)
            
        With ddsd3.ddpfPixelFormat
            
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
            If (.lRGBAlphaBitMask <> 0) Then bOK = False
        End With
        If bOK = True Then Exit For
    Next
    
    If bOK = False Then
         AddLog "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If

    If (((1 And extraFlags) _
          Or (2 And extraFlags))) Then
        ddsd3.ddpfPixelFormat.lFlags = DDPF_ALPHAPIXELS Or DDPF_RGB
        ddsd3.lFlags = ddsd.lFlags Or DDSD_PIXELFORMAT

    Else
       ddsd3.ddpfPixelFormat.lFlags = DDPF_RGB

    End If
    
    ' voodoo 2 change
    If Device.GetDeviceGuid() <> "IID_IDirect3DRGBDevice" Then
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE
            ddsd3.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            ddsd3.lTextureStage = 0

    Else
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            ddsd3.ddsCaps.lCaps2 = 0
            ddsd3.lTextureStage = 0

          ' AddLog "Texture pas normal"
    End If

    If BitmapFile = "" Then
        Set SurfaceObject = DD.CreateSurface(ddsd3)
    Else
        TestPAKFile BitmapFile
        Set SurfaceObject = DD.CreateSurfaceFromFile(BitmapFile, ddsd3)
        DeletePAKTemp BitmapFile
        
    End If
    
     SurfaceObject.GetSurfaceDesc ddsd3
     TWidth = ddsd3.lWidth
     THeight = ddsd3.lHeight
     'AddLog "Result : Create Texture success " + BitmapFile + " " + CStr(ddsd3.ddsCaps.lCaps And DDSCAPS_TEXTURE)
     For i = 1 To 100
       If TextureName(i) = "" Then Exit For
     Next i
     TXTIND = i
     
     Set texture(TXTIND) = SurfaceObject
     TextureName(TXTIND) = NameTex
    ' AddLog "TXTIND " + CStr(TXTIND)
     TextureIndex = TXTIND
     Exit Sub
789:
 AddLog "ERROR : Create surface " + Err.Description + " " + CStr(Err.Number)
 
End Sub
Public Sub LoadFromJPGGIF(BitmapFile As String, Optional width As Integer, Optional height As Integer, Optional ColorKey As Long)
    NameTex = BitmapFile
 '  If IsMissing(Width) = True Then w = 0 Else w = Width
 '  If IsMissing(Height) = True Then h = 0 Else h = Height
  ' If IsMissing(ColorKey) = True Then ColorKey = 0
    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim i As Long
    Dim ddsd3 As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean
    On Error GoTo 789
    ddsd3.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If IsMissing(width) Then w = 0: h = 0 Else w = width: h = height
    If ((h <> 0) And (w <> 0)) Then
        ddsd3.lFlags = ddsd3.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        ddsd3.lHeight = h
        ddsd3.lWidth = w
    End If
    
     
    Set enumTex = Device.GetTextureFormatsEnum()
    
   
    For i = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(i, ddsd3.ddpfPixelFormat)
            
        With ddsd3.ddpfPixelFormat
            
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
            If (.lRGBAlphaBitMask <> 0) Then bOK = False
        End With
        If bOK = True Then Exit For
    Next
    
    If bOK = False Then
         AddLog "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If

    If (((1 And extraFlags) _
          Or (2 And extraFlags))) Then
        ddsd3.ddpfPixelFormat.lFlags = DDPF_ALPHAPIXELS Or DDPF_RGB
        ddsd3.lFlags = ddsd.lFlags Or DDSD_PIXELFORMAT

    Else
       ddsd3.ddpfPixelFormat.lFlags = DDPF_RGB

    End If
    
    ' voodoo 2 change
    If Device.GetDeviceGuid() <> "IID_IDirect3DRGBDevice" Then
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE
            ddsd3.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            ddsd3.lTextureStage = 0

    Else
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            ddsd3.ddsCaps.lCaps2 = 0
            ddsd3.lTextureStage = 0

         '  AddLog "Texture pas normal"
    End If

    If BitmapFile = "" Then
        Set SurfaceObject = DD.CreateSurface(ddsd3)
    Else
        TestPAKFile BitmapFile
        Set SurfaceObject = CreateSurfaceFromFile(BitmapFile, ddsd3)
        DeletePAKTemp BitmapFile
    End If
     SurfaceObject.GetSurfaceDesc ddsd3
     TWidth = ddsd3.lWidth
     THeight = ddsd3.lHeight
'     AddLog "Result : Create Texture success " + BitmapFile + " " + CStr(ddsd3.ddsCaps.lCaps And DDSCAPS_TEXTURE)
     For i = 1 To 100
       If TextureName(i) = "" Then Exit For
     Next i
     TXTIND = i
     
     Set texture(TXTIND) = SurfaceObject
     TextureName(TXTIND) = BitmapFile
 '    AddLog "TXTIND " + CStr(TXTIND)
     TextureIndex = TXTIND
     Exit Sub
789:
 AddLog "ERROR : Create surface " + Err.Description + " " + CStr(Err.Number)

End Sub

Sub SetColorKey(Color As Long)
  Dim ck As DDCOLORKEY
   ck.high = Color
   ck.low = Color
   
  texture(TextureIndex).SetColorKey DDCKEY_SRCBLT, ck
  Device.SetRenderState D3DRENDERSTATE_COLORKEYENABLE, True
End Sub

Private Sub Class_Terminate()
 Set texture(TextureIndex) = Nothing
 TextureName(TextureIndex) = ""
End Sub


