VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "InputEngine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

Public Sub DirectInputInit()
    
    'dfini l'objet direct input sur la base de l'objet direct x
    Set DI = DirectX.DirectInputCreate()
    
    'cre le priphrique d'acquisition dikey comme tant un clavier
    Set DIDevice = DI.CreateDevice("guid_syskeyboard")
    
    'initialise le clavier
    Call DIDevice.SetCommonDataFormat(DIFORMAT_KEYBOARD)
    
    'dfinie l'environnement de travail du clavier et ses proprits
    DIDevice.SetCooperativeLevel Form1.hWnd, DISCL_NONEXCLUSIVE Or DISCL_BACKGROUND
    
    'dclenche l'acquisition du clavier
    Call DIDevice.Acquire

End Sub

Public Sub GetKeyboardState()
     Call DIDevice.GetDeviceStateKeyboard(KeyStateDI)
End Sub

Public Function GetKeyPress(Key) As Boolean
    
    'relve la valeur des touches utilises du clavier

  If KeyStateDI.Key(Key) Then GetKeyPress = True Else GetKeyPress = False
   
End Function

Public Function GetMouseX() As Long
 GetMouseX = MouseX
End Function

Public Function GetMouseY() As Long
 GetMouseY = MouseY
End Function
Public Function GetMouseButton() As Long
 GetMouseButton = MouseButton
End Function

Function KeyPressed(Key As Integer) As Boolean
 If KeyState(Key) = True Then KeyPressed = True Else KeyPressed = False
End Function


Public Sub SetMousePosition(x As Long, y As Long)
 f = SetCursorPos(x, y)
End Sub

Public Sub UnloadKeyBoard()
 Set DI = Nothing
 Set DIDevice = Nothing
End Sub

Private Sub Class_Terminate()
 Set DI = Nothing
 Set DIDevice = Nothing

End Sub


