VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Motion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'  TrueVision 0.9 : Animation
'
'--------------------------------
'  3D Skeletal Animation class
'--------------------------------
' Wrapper for Mesh().Anim
''
'
'
'
' 25-06-2000 : First release
'              AddBone

Private MI
Sub AddBone(PosX, PosY, PosZ, RotX, RotY, RotZ, Name As String, Optional ParentName As String = "")
 With Mesh(MI).Anim
   ReDim Preserve .Bones(UBound(.Bones) + 1)
   .NbBones = .NbBones + 1
   .Bones(.NbBones).Pos = Vector(PosX, PosY, PosZ)
   .Bones(.NbBones).Rot = Vector(RotX, RotY, RotZ)
   .Bones(.NbBones).Name = Name
  If ParentName <> "" Then
   For j = 1 To .NbBones
    If .Bones(j).Name = ParentName Then
     Exit For
    End If
   Next j
   .Bones(.NbBones).Parent = j
  End If
 End With
End Sub


Friend Sub InitMesh(MeshIndex)
 MI = MeshIndex
End Sub

