VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Octree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Private Face() As Integer

Public Enum TextureMode
 TV_NO_TEXTURE = 1
 TV_NUMBER_TEXTURENAME = 2
 TV_NORMAL_TEXTURENAME = 3
End Enum

Private Sub AddMesh(Mesh As Mesh)
   On Local Error Resume Next
  ind = Mesh.GetMeshIndex
  If ind = 0 Then Exit Sub
  
  'well, for this, we must first rotate and translate mesh vertexes
  
End Sub






Private Sub AddTerrain(Terrain As Terrain)
  
End Sub


Public Sub GenerateOcTree()
  ReDim Face(Octree.FaceCount)
  For i = 1 To Octree.FaceCount
   Face(i) = i
  Next i
  BuildOctree 0, Face(), Octree.FaceCount
End Sub






Public Sub LoadOctreeFile(filename As String, texture As Boolean)
 AddLog "Load octree file " + filename
 Open filename For Binary As 42
  Dim magic As String * 4
  AddLog "Check magic TVOF"
  Get #42, , magic
  If magic <> "TVOF" Then
    AddLog "LoadOctree File : Bad format file"
    Exit Sub
  End If
  AddLog "Get Octree"
  Get #42, , Octree
  AddLog "Close file"
 Close 42
 If texture = True Then
  OctreeLoadTextures
 End If
End Sub

Public Sub RenderOctree()
  ModuleOctreeRender
End Sub

Public Sub SaveOctreeFile(filename As String)
  If filename <> "" Then
  Open filename For Binary As 42
   Put #1, , "TVOF"
   Put #1, , Octree
  Close
  End If
End Sub

Public Sub SetMaxFacePerNode(MaxNodeFace As Integer)
  Octree.MaxFacePerNode = MaxNodeFace
End Sub


Public Sub SetTextureLoadingMode(LoadingMode As TextureMode, Optional TextureWidth As Long, Optional TextureHeight As Long)
 OctreeTextureMode = LoadingMode
 If IsMissing(TextureWidth) = True Then TextureWidth = 0
 If IsMissing(TextureHeight) = True Then TextureHeight = 0
 OctreeTextureWidth = TextureWidth
 OctreeTextureHeight = TextureHeight
End Sub


Private Sub Class_Initialize()
  SetMaxFacePerNode 50
End Sub


